#include "stdafx.h"
#include "AppFrameBase.h"
#include "Wnd.h"
#include "String/Encoding.h"
#include <commctrl.h> // ::InitCommonControls()
#pragma comment(lib,"comctl32.lib")
namespace Themis {

CAppFrameBase::CAppFrameBase() {
}

CAppFrameBase::~CAppFrameBase() {
}

void CAppFrameBase::Initialize(HINSTANCE hInst, HINSTANCE hPI, LPSTR lpCL, int nCS) {
    m_hInstance = hInst;
    m_hPrevInstance = hPI;
    m_lpCmdLine = lpCL;
    m_nCmdShow = nCS;
}

void CAppFrameBase::InitCommonControls() {
    ::InitCommonControls();
}

int CAppFrameBase::Run() {
    int nRet = 0;
    try {
        nRet = InnerRun();
    } catch (std::exception& e) {
        CWnd::RemoveQuitMsg();
        OnException(e.what());
    }
    return nRet;
}

void CAppFrameBase::OnException(const std::exception& e) {
    CWnd().MsgBox(L"G[FI܂", e);
}

//------------------------------------------------------------------//

CSingleAppFrameBase::CSingleAppFrameBase(): m_bFirstRun(true) {
    m_hMutex = ::CreateMutex(NULL, TRUE, Encoding::GetDefault().GetBytes(GetExclusionName()).c_str());
    Themis_DebugAssertApi(m_hMutex != NULL);
    m_bFirstRun = (::GetLastError() != ERROR_ALREADY_EXISTS);
}

CSingleAppFrameBase::~CSingleAppFrameBase() {
    if (m_hMutex != NULL) {
        ::ReleaseMutex(m_hMutex);
        ::CloseHandle(m_hMutex);
    }
}

string CSingleAppFrameBase::GetExclusionName() {
    char sz[_MAX_PATH] = {0};
    DWORD dw = ::GetModuleFileName(NULL, sz, sizeof(sz));
    string moduleName = Encoding::GetDefault().GetString(sz);
    return moduleName.Replace(L'\\', L'/');
}

/// CSingleAppFrameBasegĂʃW[NĂ邩ǂ`FbN
bool CSingleAppFrameBase::IsRunning(const CFileName& oModuleName) {
    string strExclusionName = oModuleName.Get().Replace(L"\\", L"/");
    HANDLE hMutex = ::CreateMutex(NULL, TRUE, Encoding::GetDefault().GetBytes(strExclusionName).c_str());
    if (hMutex != NULL) {
        bool bRunning = (::GetLastError() != ERROR_ALREADY_EXISTS);
        ::ReleaseMutex(hMutex);
        ::CloseHandle(hMutex);
        return bRunning;
    }
    Themis_DebugApiError();
    return false;
}

}
