#pragma once
#include "../tpl/smart_ptr_vector.h"
#include "../TempFile.h"
#include "Archiver.h"
#include <boost/enable_shared_from_this.hpp>
namespace Themis {

class CFileData;

/// CArchivȅLҏ
struct ArchiveOwner {
    IQueryArchivePassword* queryPass;
    HWND hwnd;
    ArchiveOwner(IQueryArchivePassword* p = NULL, HWND h = NULL) : queryPass(p), hwnd(h) {}
};

/**
    ̏ɂƂ̎qɂɑΉIuWFNgB

    eɂɑ΂ăR΁Aqɂ͂̃NXʓ|Ă悤ɂB

    GetFileList()iKŁAqɂ͉𓀂ႤB
    ƂX|XȂႤǁA\サ[ȂBB

    łS𓀂悤ɂ͂ȂA
    gqɂ̂Ȃ΂ȂɂƂB

    ViewNaméAɃt@CtH_݂ɂĂĂt@CƂB
    F
        L"C:\\documents\\nazo.zip\\hoge.zip"
        L"C:\\documents\\nazo.zip\\hoge.zip/moge.jpg"
       \\ 炯ƌÂ炢ĈŁA \\  / ݂̍ƂB ɓ͑S / H
    Õt@CƃtH_oȂt@CVXeɈˑĂ邯ǁA
    X̕ӂ̎dlςȂĂȂ낤Ǝv̂ŁB

*/
class CArchive : private boost::noncopyable, public std::tr1::enable_shared_from_this<CArchive> {
    CArchive(const CFileName& oTmpBaseDir, const std::tr1::weak_ptr<CArchive>& pParent, int nIndex, const ArchiveOwner& owner);
public:
    CArchive(const CFileName& oTmpBaseDir, const ArchiveOwner& owner);
    ~CArchive();

    /// pX[h₢킹IuWFNg̐ݒ
    void SetQueryPass(IQueryArchivePassword* pQueryPass);

    /// ɂJ
    bool Open(const CFileName& oFileName);

    /// ɉ𓀃tÕZbg
    void ResetExtractFlags();

    /// ݂鏑ɂ̃t@C
    CFileName GetFileName() const {
        Themis_DebugAssert(IsSupported());
        return CFileName(m_pArchiver->GetName());
    }
    /// ɂViewName擾BL"\\"B(Ⴆ L"C:\\hoge\\nazo.zip\\hoge.zip\\" )
    string GetViewName() const {
        Themis_DebugAssert(IsSupported());
        std::tr1::shared_ptr<CArchive> p = m_pParent.lock();
        return p == NULL ? m_pArchiver->GetName() + L"\\" : p->InnerGetViewFileName(m_nParentIndex) + L"\\";
        // eɂȂt@Ĉ܂܁AqȂe擾B
    }

    /// ΉĂ鏑ɂȂ̂BfalseȂȉ̃o͌ĂяoȂ悤ɁB
    bool IsSupported() const { return m_pArchiver.get() != NULL; }

    struct SFileInfo {
        string strViewName;
        std::tr1::weak_ptr<CArchive> pArchive;
        int nArchiveIndex;
        inline bool operator<(const SFileInfo& r) const {
            return strViewName < r.strViewName;
        }
    };
    /// ɓ̃t@CXg쐬
    void GetFileList(vector<CArchive::SFileInfo>& rList);

    /// ̎q̒ɂt@CȂ炻̃|C^ƓYԂBNULL-1B
    pair<std::tr1::weak_ptr<CArchive>, int> Find(const string& strViewName);

    /// t@CTCY̎擾
    size_t GetFileSize(int i);
    /// ŏIXV̎擾
    FILETIME GetLastUpdate(int i);
    /// t@C𓀂t@CIuWFNg쐬ĕԂ
    std::tr1::shared_ptr<CFileData> LoadFile(int i);

    /// fꂽSĉ𓀂ꂽĂtrue
 // bool IsExtractedAll() const { return m_bExtractedAll; }

    /// ΉĂ鏑ɂȂ̂`FbNBgqH
    static bool IsSupportedFileName(const CFileName& oFileName);

    /// eɂ̎擾
    std::tr1::weak_ptr<CArchive> GetParent() const { return m_pParent; }

private:
    std::tr1::shared_ptr<CFileData> InnerLoadFile(int nFileIndex);

    /// ɓ̃t@CViewName̎擾B/\A
    string InnerGetViewFileName(int nFileIndex) {
        return GetViewName() + m_pArchiver->GetFileName(nFileIndex);
    }

    /// ɓ̃t@C̎t@C̎擾
    CFileName InnerGetExistFileName(int nFileIndex) {
        return CFileName(m_pArchiver->GetFileName(nFileIndex), m_pTempDir->GetName());
    }

    int InnerFindFile(const string& strViewName) const;
    void InnerExtract(int nIndex);

private:
    ArchiveOwner owner;

    auto_ptr<CArchiver> m_pArchiver; //ɉ𓀏sIuWFNg
    auto_ptr<CTempDir> m_pTempDir; //𓀐e|fBNg

    vector<int> m_vctExtractFlag; // 0:𓀁A1:𓀒A2:𓀍ς݁Bt@CɃtOێ
    int extractAllFlag; // 0:𓀁A1:𓀒A2:Sĉ𓀍ς݁A-1:fA-2:s

    std::tr1::weak_ptr<CArchive> m_pParent; //ɓɂȏꍇÅKw̏ɂւ̃|C^Bʂ̏ɂȂNULL
    int m_nParentIndex; //eɓłm_nParentIndexԖڂ̃t@C̏

    smart_ptr_vector<CArchive> m_vctChildren; //qɂ
};

}
