/** @file
 * ZIPȏɂ̓ǂݏB
 *
 * @author aki.
 */
#pragma once
#include "Archiver.h"
#include "../_config.h"
namespace Themis {

#if Themis_ConfigZLib

namespace Detail {
//
// (PK34, kf[^, PK34, kf[^, ...) PK12, PK12, ..., PK56
//
// FTIME
//  time 2 bytes ʂTrbgԁiQSԁjCUrbgCcTrbgb̔H
//  date 2 bytes ʂTrbgC̎SrbgCc̏ʃrbgN킷݂
//  N1980NOH
//
  #include <pshpack1.h>
    /// t@Cwb_̂P
    struct SPK34 {
        uint32_t dwSignature;              // 0x04034b50
        uint16_t wExtractVersion;           // 0x000aH 0x0014H
        uint16_t wGeneralFlags;             // 0? 0x0002?
        uint16_t wCompressionMethod;        // 0? 0x0008?
        uint16_t wUpdateTime;
        uint16_t wUpdateDate;               // ŏIXVFFTIME
        uint32_t dwOriginalFileCrc;
        uint32_t dwCompressSize;
        uint32_t dwOriginalFileSize;
        uint16_t wFileNameLength;           // t@C̒
        uint16_t wExtensionFieldLength;     // gtB[hTCY
     // vector<char> strFileName;
     // vector<uint8_t> abyExtensionField;
    };
    /// t@Cwb_̂Q
    struct SPK12 {
        uint32_t dwSignature;              // 0x02014b50
        uint16_t wVersionMadeBy;
        uint16_t wExtractVersion;
        uint16_t wGeneralFlags;
        uint16_t wCompressionMethod;
        uint16_t wUpdateTime;
        uint16_t wUpdateDate;               // ŏIXVFFTIME
        uint32_t dwOriginalFileCrc;
        uint32_t dwCompressSize;
        uint32_t dwOriginalFileSize;
        uint16_t wFileNameLength;           // t@C̒
        uint16_t wExtensionFieldLength;     // gtB[hTCY
        uint16_t wCommentLength;            // Rg̒
        uint16_t wDiskNumber;               // fBXNio[H
        uint16_t wInternalFileAttributes;   // ̂P
        uint32_t dwExternalFileAttributes; // ̂Q
        uint32_t dwLocalHeaderOffset;
     // vector<char> strFileName;
     // vector<uint8_t> abyExtensionField;
     // vector<char> strComment;
    };
    /// tb_
    struct SPK56 {
        uint32_t dwSignature;              // 0x06054b50
        uint16_t wDiskNumber;               // 0?
        uint16_t wDirectoryNumber;          // 0?
        uint16_t wTotalDiskNumber;          // t@CH
        uint16_t wTotalNumber;              // t@CH
        uint32_t dwDirectorySize;          // PK12̑Ŝ̃TCYH
        uint32_t dwOffsetDiskNum;          // PK12JnItZbgH
        uint16_t wCommentLength;            // Rg̒
     // vector<char> strComment;        // I[\0͖
    };
  #include <poppack.h>
}

class IFile;
class CZipDecrypter;

/**
    zlibgpZIPɂ̓ǂݍ

    DLLKvāAwb_̃`FbNƂKȂ̂
    K؂t@CWJ\B

    CRCƂ̃`FbNs킸ATCYÕt@CtH_ƌȂĖ
    ȂKdlB
*/
class CZipArchiver: public IArchiver {
public:
    CZipArchiver();
    ~CZipArchiver();

private:
    virtual vector<string> InnerGetSupportedSuffixes() const;
    virtual bool InnerOpen(vector<SFile>& rList);
    virtual void InnerExtractFile(int nFileIndex, const CFileName& oDirName);
    virtual void InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData);
    virtual EType InnerGetType() const { return eTypeLoadable; }

    bool OpenSequential(vector<SFile>& rList);
    bool OpenByBackward(vector<SFile>& rList);
    void Inflate(uint8_t* p, size_t n, int nFileIndex, CZipDecrypter* pDecrypter);

private:
    struct SHeader {
        size_t  nHeaderPos;
        size_t  nHeaderSize;
        size_t  nCompressSize;  // 0Ȃ疳kƂ
        uint16_t cryptTest;     // ÍpX[h̃eXgpf[^
        bool    bCrypted;       // ÍĂtrue
    };
    boost::mutex mutex;
    auto_ptr<IFile> m_pFile;
    vector<SHeader> m_vctHeader;
    string m_pass;
    bool m_bTryPass;
};

typedef DefaultFactory<CZipArchiver, IArchiver>  CZipArchiverFactory;

class CStdFile;

/**
    ZIPɂ쐬̍쐬B蔲HCB
*/
class CZipMaker : private boost::noncopyable {
public:
    CZipMaker();
    ~CZipMaker();

    //@{ t@CEtH_̒ǉ
    CZipMaker& Add(const CFileName& oFileName);
    CZipMaker& Add(const string& strName, const CFileName& oFileName);
    //@}

    /// ɂ̍쐬B
    void Save(const CFileName& oZipFileName);

private:
    void InnerAddFile(const string& strName, const CFileName& oFileName);
    void InnerAddDir(const string& strName, const CFileName& oFileName);
    void InnerSave(CStdFile& rDstFile);
    uint32_t Compress(CStdFile& rFile, const CFileName& oSrcFileName);

private:
    struct SEntry {
        string      strName;
        CFileName   oFileName;  // ȂtH_Ƃ
        bool        bDir;
        SEntry(const string& s, const CFileName& f, bool d);
    };
    vector<SEntry> m_vctEntry;
};

#endif // Themis_ConfigZLib

}
