#include "stdafx.h"
#include "Debug.h"
#include "String/Encoding.h"
#include "Windows/NativeString.h"
#include <shellapi.h>
#pragma comment(lib, "shell32.lib")
#include <stdlib.h> // _splitpath_s
#ifdef BOOST_ENABLE_ASSERT_HANDLER
namespace boost {
    /// BOOST_ASSERT()̃nh
    void assertion_failed(const char* expr, const char* function, const char* file, long line) {
        typedef Themis::string string;
        string exprStr = Themis::Encoding::GetDefault().GetString(expr);
        string funcStr = Themis::Encoding::GetDefault().GetString(function);
        string fileStr = Themis::Encoding::GetDefault().GetString(file);
        string msg = string::Format(L"BOOST_ASSERT failed: %s\r\n\r\n%s\r\n in %s (%d)", 
            exprStr.ToCharPtr(), funcStr.ToCharPtr(), fileStr.ToCharPtr(), line);
        if (Themis::DebugMsgBox(msg)) {
            __asm int 3;
        }
    }
}
#endif
namespace Themis {

volatile int g_nLoggerCounter = 0;
const char* g_pszLogWindowPath = "..\\..\\LogWindow\\LogWindow.exe";

string DebugString(const char* psz) {
    return Encoding::GetDefault().GetString(psz);
}

string DebugItoA(int n) {
    return string::Format(L"%d", n);
}

void DebugOutput(const Themis::string& msg) {
    NativeString::IsUnicode() ?
        ::OutputDebugStringW((msg + L"\n").ToCharPtr()) :
        ::OutputDebugStringA(Encoding::GetDefault().GetBytes(msg + L"\n").c_str());
}

void DebugLog(const string& msg) {
#ifdef NDEBUG
    static struct CDebugLogWarning {
        ~CDebugLogWarning() {
            // [XrhDebugLog()Ă΂ꂽꍇAxoB
            // 肱JĂ܂ƃ_T̂ŁAǂ̂ȂƂ낾BB
            ::MessageBox(NULL, "G[", NULL, MB_TASKMODAL | MB_TOPMOST | MB_SETFOREGROUND);
        }
    } s_oDebugLogWarning;
#endif
    vector<string> vctMsgs = msg.TrimEnd().Split(Array<string>(L"\r\n", L"\n", L"\r"));
    if (1 < vctMsgs.size()) {
        for (size_t i = 0, n = vctMsgs.size(); i < n; i++) {
            DebugLog(vctMsgs[i]);
        }
    } else if (vctMsgs.size() == 1) {
        // LogWindow.exẽpX쐬BȂK
        char szPath[_MAX_DRIVE + _MAX_DIR + _MAX_FNAME + _MAX_EXT], szDir[_MAX_DIR];
        _splitpath_s(__FILE__, szPath, sizeof(szPath), szDir, sizeof(szDir), NULL, 0, NULL, 0);
        strcat(szPath, szDir);
        strcat(szPath, g_pszLogWindowPath);
        // bZ[Wo
        string strMsg = string::Format(L"%u %u %s", ::GetCurrentProcessId(), g_nLoggerCounter++, vctMsgs[0].ToCharPtr());
        HINSTANCE ret = ::ShellExecute(NULL, "open", szPath, Encoding::GetDefault().GetBytes(strMsg).c_str(), NULL, SW_SHOWNORMAL);
        // Ɉ̂͑pszMsg̕񂪒ꍇB
        // sɕ肷Α̑vȂ͂AÔ߁B
        Themis_DebugAssert((HINSTANCE)32 < ret);
    }
}

bool DebugMsgBox(const string& strMsg) {
    UINT uType = MB_ICONQUESTION | MB_YESNO | MB_TASKMODAL | MB_TOPMOST | MB_SETFOREGROUND;
    int n = ::MessageBox(NULL, Encoding::GetDefault().GetBytes(strMsg).c_str(), "s܂H", uType);
    return n == IDNO;
}

LPVOID DebugGetLastError() {
    LPVOID pMsgBuf = NULL;
    int n = ::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL, ::GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), reinterpret_cast<LPTSTR>(&pMsgBuf), 0, NULL);
    Themis_DebugAssert(n != 0);
    return pMsgBuf;
}

#if 1
#ifndef NDEBUG
}
#undef _MFC_OVERRIDES_NEW
#define _MFC_OVERRIDES_NEW
// ƂnewƂI[o[ChĂ܂B
#include <crtdbg.h>
namespace Themis {
namespace {

    bool DebugInitialize() {
        // fobOq[v̐ݒ
      //*
     // int iFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);   //ÂtO擾
        int iFlag = 0;
        iFlag |= _CRTDBG_ALLOC_MEM_DF;              //fobO q[v蓖ĂLɂ(l:I)
     // iFlag |= _CRTDBG_DELAY_FREE_MEM_DF;         //ubNNXgɕێ (l:It)
        iFlag |= _CRTDBG_CHECK_ALWAYS_DF;           //蓖ĂƉ̂т_CrtCheckMemory() (l:It)
     // iFlag |= _CRTDBG_CHECK_CRT_DF;              //CuIɎgp郁̃`FbN (l:It)
        iFlag |= _CRTDBG_LEAK_CHECK_DF;             //vȌI _CrtDumpMemoryLeaks() (l:It)
        ::_CrtSetDbgFlag(iFlag);
      /*/
        ::_CrtSetDbgFlag(0);
      //*/

        // [Nǐ՗pu[N|Cg̐ݒB
      #if 0
        ::_CrtSetBreakAlloc(2604);
      #endif
        return true;
    }

    volatile bool s_bInitialize = DebugInitialize();

}//namespace
#endif//NDEBUG
#endif

}
