#include "stdafx.h"
#include "File.h"
#include "DirObserver.h"
#include "DirFileList.h"
namespace Themis {

CDirFileList::CDirFileList() {
}

CDirFileList::~CDirFileList() {
}

void CDirFileList::Begin(const CFileName& oDirName, int nReflexive) {
    m_pFileList.reset(new vector<CFileName>(CFile::FindFile(oDirName, nReflexive)));
}

int CDirFileList::GetCount() {
    return static_cast<int>(m_pFileList->size());
}

const CFileName& CDirFileList::Get(int n) {
    return (*m_pFileList)[n];
}

void CDirFileList::End() {
    m_pFileList.reset();
}

//------------------------------------------------------------------//

CDirFileListCache::CDirFileListCache() {
    m_pObserver.reset(new CDirObserver);
    m_pFileList.reset(new CDirFileList);
}

CDirFileListCache::~CDirFileListCache() {
}

void CDirFileListCache::Begin(const CFileName& oDirName, int nReflexive) {
    if (m_pObserver->GetDirName() != oDirName) { // ႤtH_ȏꍇ
        m_pObserver->Begin(oDirName, nReflexive != 0);
        m_pFileList->Begin(oDirName, nReflexive);
    } else if (m_pObserver->IsChanged()) { // t@CύXĂꍇ
        m_pObserver->ResetChangeCount();
        m_pFileList->Begin(oDirName, nReflexive);
        Themis_DebugLog(oDirName.Get() + L" ɕύX̂ōĎ擾");
    }
}

int CDirFileListCache::GetCount() {
    return m_pFileList->GetCount();
}

const CFileName& CDirFileListCache::Get(int n) {
    return m_pFileList->Get(n);
}

void CDirFileListCache::End() {
}

}
