/** @file
 * Œ菬_ׂ̊֐Ƃ񋟁B
 *
 * ɃNXčœK肭sȂ肷
 * ӖȂ̂ŁAinline֐Ƃŉ䖝B
 *
 * @author aki.
 */
#pragma once
#include "_config.h"
#if !Themis_ConfigFint
# include <math.h>
#endif
namespace Themis {

#if Themis_ConfigFint

    namespace Detail {
        const int c_nFintShift = 16;
        const int c_nFintSize = 1 << c_nFintShift;
        const int c_nFintMask = c_nFintSize - 1;
    }

    typedef signed __int32 fint;

    const fint c_nFint_1 = static_cast<fint>(Detail::c_nFintSize);      //1.0\lBToFint(1)
    const fint c_nFint_0 = static_cast<fint>(0);                        //0.0\lBToFint(0)

    // fintւ̕ϊ
    inline fint ToFint(signed i) { return static_cast<fint>(i * Detail::c_nFintSize); }
    inline fint ToFint(unsigned i) { return static_cast<fint>(i  * Detail::c_nFintSize); }
    inline fint ToFint(float i) { return static_cast<fint>(i * Detail::c_nFintSize); }
    inline fint ToFint(double i) { return static_cast<fint>(i * Detail::c_nFintSize); }
    // fint̕ϊ
    inline signed FintToInt(fint x) { return static_cast<signed>(x) / Detail::c_nFintSize; }
    inline unsigned FintToUInt(fint x) { return static_cast<unsigned>(x) / Detail::c_nFintSize; }
    inline float FintToFloat(fint x) { return static_cast<float>(x) / Detail::c_nFintSize; }
    inline double FintToDouble(fint x) { return static_cast<double>(x) / Detail::c_nFintSize; }
    // floor:؂̂ / ceil:؂グ
    inline fint FintFloor(fint f) { return (f & ~Detail::c_nFintMask); }
    inline fint FintCeil(fint f) { return FintFloor(f + Detail::c_nFintMask); }
    inline int FintFloorToInt(fint f) { return FintToInt(f); }
    inline int FintCeilToInt(fint f) { return FintFloorToInt(f + Detail::c_nFintMask); }
    // ̎擾
    inline fint FintDecimal(fint f) { return f & Detail::c_nFintMask; }
    // |Z
    __forceinline fint FintMul(fint l, fint r) {
        enum{ _nShift = Detail::c_nFintShift };
        _asm{
            mov     eax, l
            mov     edx, r
            imul    edx
            shr     eax, _nShift
            shl     edx, _nShift
            or      eax, edx
            mov     l,  eax
        }
        return l;
    }
    __forceinline signed FintMulToInt(fint l, fint r) {
        enum{ _nShift = Detail::c_nFintShift };
        _asm{
            mov     eax, l
            mov     edx, r
            imul    edx
            mov     l, edx
        }
        return static_cast<signed>(l);
    }
    __forceinline fint UFintMul(fint l, fint r) {
        enum{ _nShift = Detail::c_nFintShift };
        _asm{
            mov     eax, l
            mov     edx, r
            mul     edx
            shr     eax, _nShift
            shl     edx, _nShift
            or      eax, edx
            mov     l,  eax
        }
        return l;
    }
    __forceinline unsigned UFintMulToUInt(fint l, fint r) {
        enum{ _nShift = Detail::c_nFintShift };
        _asm{
            mov     eax, l
            mov     edx, r
            mul     edx
            mov     l, edx
        }
        return static_cast<unsigned>(l);
    }
    // Z
    inline fint FintDiv(fint l, fint r) { return static_cast<fint>((static_cast<signed __int64>(l) << Detail::c_nFintShift) / r); }
    inline fint UFintDiv(fint l, fint r) { return static_cast<fint>((static_cast<unsigned __int64>(l) << Detail::c_nFintShift) / r); }

#else

    typedef double fint;

    const fint c_nFint_1 = static_cast<fint>(1.0);
    const fint c_nFint_0 = static_cast<fint>(0.0);

    // fintւ̕ϊ
    inline fint ToFint(signed i) { return static_cast<fint>(i); }
    inline fint ToFint(unsigned i) { return static_cast<fint>(i); }
    inline fint ToFint(float i) { return static_cast<fint>(i); }
    inline fint ToFint(double i) { return static_cast<fint>(i); }
    // fint̕ϊ
    inline signed FintToInt(fint x) { return static_cast<signed>(x); }
    inline unsigned FintToUInt(fint x) { return static_cast<unsigned>(x); }
    inline float FintToFloat(fint x) { return static_cast<float>(x); }
    inline double FintToDouble(fint x) { return static_cast<double>(x); }
    // floor:؂̂ / ceil:؂グ
    inline fint FintFloor(fint f) { return floor(f); }
    inline fint FintCeil(fint f) { return ceil(f); }
    inline int FintFloorToInt(fint f) { return FintToInt(f); }
    inline int FintCeilToInt(fint f) { return FintToInt(FintCeil(f)); }
    // ̎擾
    inline fint FintDecimal(fint f) { return f - FintToInt(f); }
    // |Z
    __forceinline fint FintMul(fint l, fint r) { return l * r; }
    __forceinline signed FintMulToInt(fint l, fint r) { return static_cast<signed>(l * r); }
    __forceinline fint UFintMul(fint l, fint r) { return l * r; }
    __forceinline unsigned UFintMulToUInt(fint l, fint r) { return static_cast<signed>(l * r); }
    // Z
    inline fint FintDiv(fint l, fint r) { return l / r; }
    inline fint UFintDiv(fint l, fint r) { return l / r; }

#endif//Themis_ConfigFint

}
