#pragma once
#include "KeyTable.h"
#include "MsgHook.h"
namespace Themis {

/**
 * L[RtBO̐ݒlIuWFNg
 */
class HotKeySetting : private boost::noncopyable {
    struct SKey {
        CKeyTable::EKey eKey;
        int nModifiers;
        inline SKey(CKeyTable::EKey e, int n): eKey(e), nModifiers(n) {}
        inline bool operator<(const SKey& r) const {
            return eKey == r.eKey ? nModifiers < r.nModifiers : eKey < r.eKey;
        }
        inline bool operator==(const SKey& r) const {
            return eKey == r.eKey && nModifiers == r.nModifiers;
        }
    };

    std::map<SKey, int> m_oIdList;                  // SKeyID擾
    std::map<int, std::set<SKey> > m_oKeyList;      // IDSKey擾AȏꍇAB
protected:
    mutable boost::recursive_mutex mutex;
public:
    HotKeySetting();
    ~HotKeySetting();

    /// S폜
    void Clear();
    /// eKey{nModifiersȓo^폜
    void Remove(CKeyTable::EKey eKey, int nModifiers);
    //@{ ǉBnHotKeyIdGetId()̎s-1ɂ̂ŁA0ȏɂƂׂB
    void Add(int nHotKeyId, CKeyTable::EKey eKey, int nModifiers);
    void Add(int nHotKeyId, const string& str);
    //@}

    /// L[ɑΉR}hID擾Bs-1
    int GetId(CKeyTable::EKey eKey, int nModifiers) const;
    /// IDɑΉL[\̎擾i", Space, ENbN"jƂ
    string GetKeyStr(int nHotKeyId) const;

    /// ݒۑ
    void SaveToConfig(const CFileName& oFileName, HotKeySetting& defaultSetting);
    /// ݒǂݍ
    void LoadFromConfig(const CFileName& oFileName, HotKeySetting& defaultSetting);

private:
    void InnerAdd(int nHotKeyId, const string& str);
};

/**
 * V[gJbgL[̏sB
 *
 * ShortcutKey̕₷C邯ǁA
 * SŎn܂郂mČ\̂ŁB
 *
 * Cӌ̃V[gJbgL[ƁA
 * L[ꂽɑMPHotKeyIdΉtB
 */
class CHotKey: private IMsgHooker, public HotKeySetting {
public:
    /** HotKey̒ʒm󂯂IuWFNgB

        void OnHotKey(CHotKey* pHotKey, int nHotKeyId);
    */
    class IOwner {
    public:
        virtual ~IOwner() {}
        virtual void OnHotKey(CHotKey* pHotKey, int nHotKeyId) = 0;
    };

    CHotKey(const std::tr1::shared_ptr<IOwner>& pOwner);
    ~CHotKey();

    void AddToHook(CMsgHook& rMsgHook) { rMsgHook.Add(this); }

private:
    bool HookMsg(CMsgHookPrms& rPrms);
    bool OnInput(CKeyTable::EKey eKey, int nModifier);

private:
    std::tr1::shared_ptr<IOwner> m_pOwner;
};

}
