#pragma once
#include "Image.h"
namespace Themis {

/**
    BMPt@Cǂݍ݃NX
*/
class CBmpLoader: public IImageLoader {
public:
    bool Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce);
    CSize GetSize() const;
    void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce);
    bool HasAlpha() const;
    string GetTypeName() const { return L"BITMAP"; }
    string GetTypeFileName() const { return L"*.bmp;*.dib"; }

private:
    const BITMAPINFO*   m_bi;
    const uint8_t*         m_pBits;
    boost::scoped_array<uint8_t>    m_abyBits;
};

/**
    BMPt@C̏o
*/
class CBmpSaver: public IImageSaver {
public:
    void Save(const CFileName& oFileName, const CPlane& src, const CRect& rc);
};

/// BMPt@Cǂݍ݃NXFactory
typedef DefaultFactory<CBmpLoader, IImageLoader>   CBmpLoaderFactory;

}
