#pragma once
#include "../_config.h"
#include "Image.h"
struct jpeg_decompress_struct;
struct jpeg_compress_struct;
struct jpeg_error_mgr;
namespace Themis {

#if Themis_ConfigJpgLib

/**
    JPEGǂݍ݁B
*/
class CJpgLoader : public IImageLoader {
public:
    CJpgLoader();
    ~CJpgLoader();

    bool Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce);
    CSize GetSize() const;
    void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce);
    bool HasAlpha() const { return false; }
    string GetTypeName() const { return L"JPEG"; }
    string GetTypeFileName() const { return L"*.jpg;*.jpeg;*.jpe"; }

private:
    void Decompress(CPlane& dst, const CPoint& pt) const;
    auto_ptr<jpeg_decompress_struct>    m_pcinfo;
    auto_ptr<jpeg_error_mgr>            m_pjerr;
    auto_ptr<CMemoryPlane>              m_pPlane;
    std::tr1::shared_ptr<CFileData> fileData;
};

/**
    JPEGۑB
*/
class CJpgSaver : public IImageSaver {
public:
    CJpgSaver();
    ~CJpgSaver();

    /// 0`100̉掿ݒ
    CJpgSaver& SetQuality(int nQuality);
    /// vOXJPEGɂSaveOɃRĂ
    CJpgSaver& SetProgress();

    void Save(const CFileName& oFileName, const CPlane& src, const CRect& rc);

private:
    auto_ptr<jpeg_compress_struct>  m_pcinfo;
    auto_ptr<jpeg_error_mgr>        m_pjerr;
};

/// JPEGt@Cǂݍ݃NXFactory
typedef DefaultFactory<CJpgLoader, IImageLoader>   CJpgLoaderFactory;

#endif//Themis_ConfigJpgLibs

}
