#pragma once
#include "Exclusion.h"
#include "String/Encoding.h"
#include "Windows/NativeString.h"
namespace Themis {

/**
 * nrxł̔rsIuWFNgB
 */
class CProcessExclusion : public IExclusion {
    HANDLE handle;
    string m_strName;
public:
    CProcessExclusion(const string& strName)
        : handle(NULL), m_strName(strName.Replace(L"\\", L"/")) {
        // mutex\\gȂ̂ŒuƂ
        // ͍ő_MAX_PATHȂ̂ŁAȏ゠Ȃ炵Ȃ̂Ő؂̂Ă
        if (_MAX_PATH <= m_strName.GetLength()) {
            Themis_DebugLog(L"ProcessExclusion_MAX_PATHȏ̒ۂ");
            m_strName = m_strName.Substring(0, _MAX_PATH - 1);
        }
    }
    ~CProcessExclusion() {
        Unlock();
    }

    virtual void Lock() {
        Themis_DebugAssert(handle == NULL);
        Unlock(); // Ô
        handle = NativeString::IsUnicode() ?
            ::CreateMutexW(NULL, TRUE, m_strName.ToCharPtr()) :
            ::CreateMutexA(NULL, TRUE, Encoding::GetDefault().GetBytes(m_strName).c_str());
        Themis_DebugAssertApi(handle != NULL);
        if (::GetLastError() == ERROR_ALREADY_EXISTS) {
            ::WaitForSingleObject(handle, INFINITE);
        }
    }
    virtual void Unlock() {
        if (handle != NULL) {
            ::ReleaseMutex(handle);
            ::CloseHandle(handle);
            handle = NULL;
        }
    }

private:
};

/**
 * CProcessExclusion͎ĝĂł\Ȃ̂ŁA
 * sŏ悤ɂĂ݂
 */
class CProcessExclusionLock : private boost::noncopyable {
    CProcessExclusion exclusion;
    IExclusion::CLock lock;
public:
    CProcessExclusionLock(const string& strName)
        : exclusion(strName), lock(exclusion) {}
    ~CProcessExclusionLock() {}
};

}
