/** @file
 * fread()Ƃ̃pI[o[[hB
 * cƍpB
 * @author aki.
 */
#pragma once
namespace Themis {

struct MFILE {
    const void* const memory;
    const size_t size;
    size_t pos;
    MFILE(const void* memory, size_t size) : memory(memory), size(size), pos(0) {}
};

static inline MFILE* fopen(const void* memory, size_t size) {
    return new MFILE(memory, size);
}
/// filenamesize_t*[2]𖳗荞ށB
static inline MFILE* fopen(const char* filename, const char* mode) {
    BOOST_ASSERT(strcmp(mode, "rb") == 0);
    size_t** a = (size_t**)filename;
    return fopen(a[0], ((size_t*)a)[1]);
}

static inline int fclose(MFILE* fp) {
    delete fp;
    return 0;
}

static inline int feof(MFILE* fp) {
    return fp->size <= fp->pos;
}

static inline int fflush(MFILE* fp) { return 0; }
static inline int ferror(MFILE* fp) { return 0; }

static inline int fgetc(MFILE* fp) {
    return feof(fp) == 0 ? ((const char*)fp->memory)[fp->pos++] : EOF;
}

static inline int fread(void* buffer, size_t size, size_t count, MFILE* fp) {
    // 蔲C
    for (size_t i = 0; i < count; i++) {
        if (fp->size < fp->pos + size * i + size) {
            count = i - 1;
            break;
        }
    }
    if (count <= 0) return 0;
    size_t n = size * count;
    memcpy(buffer, ((const uint8_t*)fp->memory) + fp->pos, n);
    fp->pos += n;
    return count;
}

static inline int fseek(MFILE* fp, long offset, int origin) {
    size_t n = 0;
    switch (origin) {
    case SEEK_SET: n = offset; break;
    case SEEK_CUR: n = fp->pos + offset; break;
    case SEEK_END: n = fp->size - offset; break;
    default: BOOST_ASSERT(false && "fseekorigins"); return !0;
    }

    if (0 <= n && n < fp->size) {
        fp->pos = n;
        return 0;
    } else {
        return !0;
    }
}

static inline long ftell(MFILE* fp) { return (long)fp->pos; }

static inline int fwrite(const void* buffer, size_t size, size_t count, MFILE* fp) {
    BOOST_ASSERT(false && "");
    return 0;
}

}
