#pragma once
#include "Windows/DialogResult.h"
#include "Wnd.h"
#include "WndCtrl.h"
#include "MsgHook.h"
namespace Themis {

namespace Detail {
    struct SWindowThreadData;
    struct SWindowCreateParam;
}

class IWindowParameter : private boost::noncopyable {
public:
    IWindowParameter(): m_bActiveOnCreate(true) {}
    virtual ~IWindowParameter() {}
    //@{ 쐬ɃANeBuɂ̂ǂ
    void SetActiveOnCreate(bool b) { m_bActiveOnCreate = b; }
    bool IsActiveOnCreate() const { return m_bActiveOnCreate; }
    //@}
private:
    bool    m_bActiveOnCreate;
};

/// 쐬̃p[^
class CWindowParameter : public IWindowParameter {
public:
    /// ftHgl̐ݒ
    CWindowParameter();
    //@{ ݒ̕ύX
    DWORD& GetStyle() { return dwStyle; }
    DWORD& GetExStyle() { return dwExStyle; }
    void SetMenu(HMENU h) { hMenu = h; }
    void SetParent(HWND h) { hParent = h; }
    void SetClassName(const string& s) { className = s; }
    //@}
    //@{ ݒ̎擾
    DWORD GetStyle() const { return dwStyle; }
    DWORD GetExStyle() const { return dwExStyle; }
    HMENU GetMenu() const { return hMenu; }
    HWND GetParent() const { return hParent; }
    const string& GetClassName() const { return className; }
    //@}
private:
    DWORD dwStyle;
    DWORD dwExStyle;
    HMENU hMenu;
    HWND hParent;
    string className;
};

/// \[X_CAO쐬̃p[^
class CDialogParameter : public IWindowParameter {
public:
    /// ftHgl̐ݒ
    explicit CDialogParameter(int nId) : m_nId(nId), m_hParent(NULL) {}
    /// e
    void SetParent(HWND h) { m_hParent = h; }
    /// e
    HWND GetParent() const { return m_hParent; }
    /// \[XID
    int GetId() const { return m_nId; }
private:
    int     m_nId;
    HWND    m_hParent;
};

/// [_ȃ_CAO쐬̃p[^(Ƃ肠CDialogParameterRsy)
class CModalDialogParameter: public IWindowParameter {
public:
    /// ftHgl̐ݒ
    explicit CModalDialogParameter(int nId) : m_nId(nId), m_hParent(NULL) {}
    /// e
    void SetParent(HWND h) { m_hParent = h; }
    /// e
    HWND GetParent() const { return m_hParent; }
    /// \[XID
    int GetId() const { return m_nId; }
private:
    int     m_nId;
    HWND    m_hParent;
};

/**
    EBhEB

    pȂĂׂg₷悤
    WM_CLOSE󂯂Ăł͑Ȃ̂ŁA
    Delete()ĂяoR[h͎gpӂ邱ƁB

    ܂ADelete()͂̃EBhẼbZ[Wɑ΂ĎsȂ΂ȂȂB
    fXgN^ƂSendMessageőꂽWM_CLOSEƂĂ񂾂肷ƎŝŒӂ邱ƁB
    ҂̏ꍇPostMessagegׂB

    [__CAȌꍇADelete() ̑ DeleteModalDialog() gp邱ƂŁA
    CWindow::Create() ̖߂lwoB(Delete()̏ꍇ͂O)
    A-1̓G[ƌȂ̂Œӂ邱ƁB
*/
class CWindow : public CWnd, private IMsgHooker {
public:
    typedef void (* FnException)(const std::exception& e, void* pParam);

    CWindow();
    ~CWindow();

    //@{ 쐬
    void Create(const CWindowParameter& rParameter);
    void Create(const CDialogParameter& rParameter);
    int Create(const CModalDialogParameter& rParameter);
    //@}
    //@{ bZ[W|vXbh쐬đ쐬
    void CreateWithThread(const CWindowParameter& rParameter);
    void CreateWithThread(const CDialogParameter& rParameter);
    //@}
    //@{ E_CAO̍폜
    void Delete();
    //@}

    /// CreateĂ񂾎trueɂȂāAbZ[W[vIfalseɂȂ
    bool IsMsgLoopValid();
    /// bZ[W҂
    void WaitMsg();
    /// MsgLoopI܂ő҂
    void WaitForQuit();
    /// ĂяoꂽXbh̑bZ[W
    bool MsgPumping();

    /// MsgHookIuWFNg̎擾
    CMsgHook& GetHook() { return *m_pMsgHook; }

    /// bZ[W̗O⑫̏[`ݒ
    void SetExceptionHandler(FnException fn, void* p) { m_fnException = fn; m_pExceptionParam = p; }
    /// ftHgExceptionHandlerݒ
    void SetDefaultExceptionHandler();

    /// ANZ[^[e[u̎擾
    HACCEL GetAccel() const { return m_hAccel; }
    /// ANZ[^[e[u̐ݒ
    void SetAccel(HACCEL hAccel) { m_hAccel = hAccel; }
    /// ANZ[^[e[u̐ݒ
    void SetAccel(int nID);
    /// ANZ[^[e[u𖢐ݒɁB
    void UnsetAccel() { SetAccel(static_cast<HACCEL>(NULL)); }

    /// J[\\(ɕ\Ăfalse)
    void ShowCursor();
    /// J[\\(ɔ\false)
    void HideCursor();

    /// bZ[W|vXbhID擾
    DWORD GetThreadId() const { return ::GetWindowThreadProcessId(GetHandle(), NULL); }

    /// ̃NX쐬EBhẼXbhȂtrueԂB
    static bool IsOwnWindowThread(DWORD dwThreadId);

    //@{ DialogResult̐ݒƎ擾ƁB
    DialogResult::T GetResult() const { return result; }
    void SetResult(DialogResult::T t) { result = t; }
    //@}

private:
    void OnThread(Detail::SWindowCreateParam* pParam);
    void Initialize(Detail::SWindowCreateParam& rParam);
    void InnerCreate(const IWindowParameter& rParameter);
    void InnerDialogCreate(const IWindowParameter& rParameter);
    void InnerDialogCreateModal(const IWindowParameter& rParameter);
    static LRESULT CALLBACK StartWindowProc(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm);
    static LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm);
    static BOOL CALLBACK StartDialogProc(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm);
    static BOOL CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm);
    LRESULT InnerWindowProc(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm);
    BOOL InnerDialogProc(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm);
    bool InnerWindowProc(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm, LRESULT* pRet);
    bool HookMsg(CMsgHookPrms& rPrms);

private:
    enum EMode { EModeWindow, EModeDialog, EModeDialogModal };
    EMode                   m_eMode;
    CMsgHook*               m_pMsgHook;
    string                  m_strClassName;
    WNDPROC                 m_fnWndProc;
    FnException             m_fnException;
    void*                   m_pExceptionParam;
    HACCEL                  m_hAccel;
    auto_ptr<Detail::SWindowThreadData> m_pThreadData;
    volatile int            m_nCursorState;     //0:A1:ShowA2:Hide

    DialogResult::T result;
};

////////////////////////////////////////////////////////////////////////////////

/**
    j[o[ƂNX
*/
class CMenu : private boost::noncopyable {
public:
    CMenu(HMENU hMenu) : m_hMenu(hMenu) {}
    ~CMenu() {}

    /// j[ڂ͗LȂ̂
    bool IsEnabled(UINT nId);
    /// j[ڂLɂ薳ɂ
    void SetEnable(UINT nId, bool bEnabled);
    /// Lǂ𔽓]āA]ɗLȂtrue
    bool ReverseEnabled(UINT nId);

    /// j[ڂ̓`FbNĂ̂
    bool GetCheck(UINT nId);
    /// j[ڂɃ`FbN`FbNO
    void SetCheck(UINT nId, bool bChecked);
    /// `FbNԂ𔽓]āA]Ƀ`FbNĂ邩ǂԂ
    bool ReverseChecked(UINT nId);

    /// ڂ̕擾
    string GetText(UINT nId);
    /// ڂ̕ݒ
    void SetText(UINT nId, const string& strCaption);

    //@{ ځEZp[^[̑}
    void AddItem(UINT nId, const string& strCaption);
    void InsertItem(UINT nPos, UINT nId, const string& strCaption);
    void AddSeparator();
    void InsertSeparator(UINT nPos);
    //@}

    /// nh̎擾
    HMENU GetHandle() { return m_hMenu; }

protected:
    void SetHandle(HMENU hMenu) { m_hMenu = hMenu; }

private:
    HMENU   m_hMenu;
};


/**
    ::CreatePopupMenu()Ƃ̃bp[B
*/
class CPopupMenu : public CMenu {
public:
    CPopupMenu();
    ~CPopupMenu();
    HMENU Release();
};

/**
    ::LoadMenu()Ƃ̃bp[B
*/
class CResMenu : public CMenu {
public:
    CResMenu(int nResId);
    ~CResMenu();
};

////////////////////////////////////////////////////////////////////////////////

/**
    Xe[^Xo[EBhEɂׂ̃NXB

    }`XbhĂSendMsgnŌł܂邱Ƃ̂ŁA
    SetTextnPostMsggB
*/
class CStatusbar : private IMsgHooker {
public:
    CStatusbar(HWND hWnd, CMsgHook& rHook);
    ~CStatusbar();

    /// ɂ
    void Attach();
    /// O
    void Detach();

    /// Xe[^Xo[̋؂(int nPart, bool bFromLeft)
    typedef vector<pair<int, bool> >  TPartsArray;
    /// ؂Zbg
    void SetParts(const TPartsArray& r);

    /// Zbg
    void SetText(int n, const string& strMsg);

    /// Xe[^Xo[͍쐬Ă̂
    bool IsAttached() const { return (m_hStatus != NULL); }

private:
    /// bZ[W̏
    bool HookMsg(CMsgHookPrms& rPrms);
    void InnerSetParts();
    LRESULT SendMsg(UINT u, WPARAM w, LPARAM l) { return ::SendMessage(m_hStatus, u, w, l); }
    BOOL PostMsg(UINT u, WPARAM w, LPARAM l) { return ::PostMessage(m_hStatus, u, w, l); }

private:
    HWND            m_hWindow;
    HWND            m_hStatus;
    TPartsArray     m_oParts;
    int             m_nHeight;
    vector<std::string> m_oTexts;
};

}
