#include "stdafx.h"
#include "Registry.h"
#include "../String/Encoding.h"
namespace Themis {

/// ݂邩ǂB
bool CRegistry::Exists(HKEY hCurrent, const string& strName) {
    REGSAM sam = 0; // KEY_READ;
    HKEY m_hKey = NULL;
    if (::RegOpenKeyEx(hCurrent, Encoding::GetDefault().GetBytes(strName).c_str(), 0, sam, &m_hKey) != ERROR_SUCCESS) {
        return false;
    }
    ::RegCloseKey(m_hKey);
    return true;
}

void CRegistry::Open(HKEY hCurrent, const string& strName, bool write) {
    Close();
    REGSAM sam = write ? KEY_ALL_ACCESS : KEY_READ;
    if (::RegOpenKeyEx(hCurrent, Encoding::GetDefault().GetBytes(strName).c_str(), 0, sam, &m_hKey) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ̃I[vɎs܂");
    }
}

bool CRegistry::Create(HKEY hCurrent, const string& strName) {
    Close();
    DWORD dwDisp = 0;
    if (::RegCreateKeyEx(hCurrent, Encoding::GetDefault().GetBytes(strName).c_str(), 0, NULL, 0, KEY_ALL_ACCESS, NULL, &m_hKey, &dwDisp) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ̍쐬Ɏs܂");
    }
    return dwDisp == REG_CREATED_NEW_KEY;
}

void CRegistry::Open(const string& strName, bool write) {
    REGSAM sam = write ? KEY_ALL_ACCESS : KEY_READ;
    HKEY hKey = NULL;
    if (::RegOpenKeyEx(m_hKey, Encoding::GetDefault().GetBytes(strName).c_str(), 0, sam, &hKey) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ̃I[vɎs܂");
    }
    Close();
    m_hKey = hKey;
}

bool CRegistry::Create(const string& strName) {
    HKEY hKey = NULL;
    DWORD dwDisp = 0;
    if (::RegCreateKeyEx(m_hKey, Encoding::GetDefault().GetBytes(strName).c_str(), 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ̍쐬Ɏs܂");
    }
    Close();
    m_hKey = hKey;
    return dwDisp == REG_CREATED_NEW_KEY;
}

void CRegistry::Close() {
    if (m_hKey != NULL) {
        ::RegCloseKey(m_hKey);
        m_hKey = NULL;
    }
}

void CRegistry::Delete(HKEY hCurrent, const string& strName) {
    ::RegDeleteKey(hCurrent, Encoding::GetDefault().GetBytes(strName).c_str());
}

void CRegistry::Num(const string& strName, int nValue) {
    if (::RegSetValueEx(m_hKey, string::IsNullOrEmpty(strName)? NULL: Encoding::GetDefault().GetBytes(strName).c_str(), 0, REG_DWORD, reinterpret_cast<const BYTE*>(&nValue), sizeof(nValue)) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ւ̒l̐ݒɎs܂");
    }
}

void CRegistry::Str(const string& strName, const string& msg) {
    std::string strMsg = Encoding::GetDefault().GetBytes(msg);
    if (::RegSetValueEx(m_hKey, string::IsNullOrEmpty(strName)? NULL: Encoding::GetDefault().GetBytes(strName).c_str(), 0, REG_SZ,
        reinterpret_cast<const BYTE*>(strMsg.c_str()), static_cast<DWORD>(strMsg.length())) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ւ̐̕ݒɎs܂");
    }
}

void CRegistry::Bin(const string& strName, const void* pBuf, size_t nSize) {
    if (::RegSetValueEx(m_hKey, string::IsNullOrEmpty(strName)? NULL: Encoding::GetDefault().GetBytes(strName).c_str(), 0, REG_BINARY,
        static_cast<const BYTE*>(pBuf), static_cast<DWORD>(nSize)) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ւ̃f[^̐ݒɎs܂");
    }
}

void CRegistry::Bin(const string& strName, const vector<uint8_t>& vct) {
    Bin(strName, &vct[0], vct.size());
}

int CRegistry::Num(const string& strName) {
    DWORD dwData, dwSize = sizeof(dwData);
    if (::RegQueryValueEx(m_hKey, string::IsNullOrEmpty(strName)? NULL: Encoding::GetDefault().GetBytes(strName).c_str(), NULL, NULL, reinterpret_cast<BYTE*>(&dwData), &dwSize) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ̒l̎擾Ɏs܂");
    }
    return static_cast<int>(dwData);
}

string CRegistry::Str(const string& strName) {
    char sz[0x100];
    DWORD dwSize = sizeof(sz);
    if (::RegQueryValueEx(m_hKey, string::IsNullOrEmpty(strName)? NULL: Encoding::GetDefault().GetBytes(strName).c_str(), NULL, NULL, reinterpret_cast<BYTE*>(&sz[0]), &dwSize) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ̎̕擾Ɏs܂");
    }
    return Encoding::GetDefault().GetString(sz);
}

vector<uint8_t> CRegistry::Bin(const string& strName, size_t nSize) {
    vector<uint8_t> vct(nSize);
    DWORD dwSize = static_cast<DWORD>(nSize);
    if (::RegQueryValueEx(m_hKey, string::IsNullOrEmpty(strName)? NULL: Encoding::GetDefault().GetBytes(strName).c_str(), NULL, NULL, static_cast<BYTE*>(&vct[0]), &dwSize) != ERROR_SUCCESS) {
        throw RuntimeException(L"WXgL[ '" + strName + L"' ̃f[^̎擾Ɏs܂");
    }
    return vct;
}

}
