#pragma once
#include "../Window.h"
namespace Themis {

/**
    pĈȉ̃o`B

    RsypTv
@code

#include <Themis/Windows/ResourceDialogBase.h>
namespace Themis {
class CConfig;
}

class CHogeHogeDialog : public CResourceDialogBase {
public:
    CHogeHogeDialog(CConfig& rConfig);
    ~CHogeHogeDialog();

private:
    bool HookMsg(CMsgHookPrms& rPrms);
    void LoadFromConfig();
    void SaveToConfig();
    CConfig& m_rConfig;
};

@endcode@code

CHogeHogeDialog::CHogeHogeDialog(CConfig& rConfig) : CResourceDialogBase(IDD_DIALOG1), m_rConfig(rConfig) {
}

CHogeHogeDialog::~CHogeHogeDialog() {
}

bool CHogeHogeDialog::HookMsg(CMsgHookPrms& rPrms) {
    if (rPrms.GetMsg() == WM_COMMAND) {
        switch (rPrms.GetWPrmLoWord()) {
        case IDOK:
            SaveToConfig();
            GetDialog().SetResult(DialogResult::OK);
            GetDialog().Close();
            break;
        case IDCANCEL:
            GetDialog().Close();
            break;
        default:
            return false;
        }
        return true;
    } else if (rPrms.GetMsg() == WM_INITDIALOG) {
        CWnd oParentWindow(GetDialog().GetParent());
        if (oParentWindow.Exists()) {
            GetDialog().SetPosClip(oParentWindow.ToScreen(oParentWindow.GetClientSize().GetCenterOf(GetDialog().GetSize())));  //
        }
        LoadFromConfig();
        return true;
    } else if (rPrms.GetMsg() == WM_CLOSE) {
        GetDialog().Delete();
        return true;
    } else {
        return false;
    }
}

void CHogeHogeDialog::LoadFromConfig() {
}

void CHogeHogeDialog::SaveToConfig() {
}

@endcode
*/
class CResourceDialogBase : private IMsgHooker {
public:
    CResourceDialogBase(int nResourceId) : m_nResourceId(nResourceId) {
        m_pDialog.reset(new CWindow);
        m_pDialog->GetHook().Add(this);
    }
    virtual ~CResourceDialogBase() {
    }

    /// [__CAOƂĎsB߂ĺACWindow::DeleteModalDialog()̈A0B
    int Open(HWND hParent) {
        ::ShowCursor(TRUE);
        ::ShowCursor(TRUE);

        CModalDialogParameter oPrm(m_nResourceId);
        oPrm.SetParent(hParent);
        int nRet = m_pDialog->Create(oPrm);

        CWnd(hParent).SetForeground();

        ::ShowCursor(FALSE);
        ::ShowCursor(FALSE);

        return nRet;
    }
    //@{ [hX_CAOƂĎs
    void OpenModeless(HWND hParent, bool bShow = true) {
        CDialogParameter oPrm(m_nResourceId);
        oPrm.SetParent(hParent);
        m_pDialog->Create(oPrm);
        if (bShow) {
            m_pDialog->Show();
        }
    }
    void OpenModelessWithThread(HWND hParent, bool bShow = true) {
        CDialogParameter oPrm(m_nResourceId);
        oPrm.SetParent(hParent);
        m_pDialog->CreateWithThread(oPrm);
        if (bShow) {
            m_pDialog->Show();
        }
    }
    //@}

protected:
    CWindow& GetDialog() const { return *m_pDialog; }

private:
    virtual bool HookMsg(CMsgHookPrms& rPrms) = 0;

private:
    const int m_nResourceId;
    auto_ptr<CWindow> m_pDialog;
};

}
