#include "stdafx.h"
#include "SharedMemory.h"
#include "../String/Encoding.h"
namespace Themis {

CSharedMemory::CSharedMemory(): m_hMap(NULL), m_pMemory(NULL) {
}

CSharedMemory::~CSharedMemory() {
    Release();
}

bool CSharedMemory::Create(const string& strName, size_t nSize) {
    Release();
    m_hMap = ::CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, static_cast<DWORD>(nSize), Encoding::GetDefault().GetBytes(strName).c_str());
    if (m_hMap != NULL && ::GetLastError() != ERROR_ALREADY_EXISTS) {
        m_pMemory = ::MapViewOfFile(m_hMap, FILE_MAP_WRITE, 0, 0, 0);
        if (m_pMemory != NULL) {
            return true;
        }
    }
    return false;
}

bool CSharedMemory::WriteOpen(const string& strName) {
    Release();
    m_hMap = ::OpenFileMapping(FILE_MAP_WRITE, FALSE, Encoding::GetDefault().GetBytes(strName).c_str());
    if (m_hMap != NULL) {
        m_pMemory = ::MapViewOfFile(m_hMap, FILE_MAP_WRITE, 0, 0, 0);
        if (m_pMemory != NULL) {
            return true;
        }
    }
    return false;
}

bool CSharedMemory::ReadOpen(const string& strName) {
    Release();
    m_hMap = ::OpenFileMapping(FILE_MAP_READ, FALSE, Encoding::GetDefault().GetBytes(strName).c_str());
    if (m_hMap != NULL) {
        m_pMemory = ::MapViewOfFile(m_hMap, FILE_MAP_READ, 0, 0, 0);
        if (m_pMemory != NULL) {
            return true;
        }
    }
    return false;
}

void CSharedMemory::Release() {
    if (m_hMap != NULL) {
        if (m_pMemory != NULL) {
            ::UnmapViewOfFile(m_pMemory);
        }
        ::CloseHandle(m_hMap);
    }
}

}
