#include "stdafx.h"
#include "SystemRand.h"
#include <wincrypt.h>
#include "Dll.h"
namespace Themis {

SystemRand::SystemRand() : hProv(NULL) {
    pDll.reset(new CDll(L"ADVAPI32.DLL"));
    typedef BOOL (WINAPI* CAC)(HCRYPTPROV*, LPCWSTR, LPCWSTR, DWORD, DWORD);
    CAC cac = (CAC)pDll->GetProc(L"CryptAcquireContextW");
    if (cac((HCRYPTPROV*)&hProv, NULL, NULL, PROV_RSA_FULL, 0) == FALSE) {
        Themis_DebugApiLog();
    }
}

SystemRand::~SystemRand() {
    if (hProv != NULL) {
        typedef BOOL (WINAPI* CRC)(HCRYPTPROV, DWORD);
        CRC crc = (CRC)pDll->GetProc(L"CryptReleaseContext");
        if (crc((HCRYPTPROV)hProv, 0) == FALSE) {
            Themis_DebugApiError();
        }
    }
}

bool SystemRand::GenRandom(void* p, size_t n) {
    if (hProv != NULL) {
        typedef BOOL (WINAPI* CGR)(HCRYPTPROV, DWORD, BYTE*);
        CGR cgr = (CGR)pDll->GetProc(L"CryptGenRandom");
        if (cgr((HCRYPTPROV)hProv, (DWORD)n, (BYTE*)p) != FALSE) {
            return true;
        }
        Themis_DebugApiError();
    }
    return false;
}

boost::optional<unsigned> SystemRand::GenRandom() {
    if (hProv != NULL) {
        unsigned nRand;
        if (GenRandom(&nRand, sizeof(nRand))) {
            return nRand;
        }
    }
    return boost::optional<unsigned>();
}

SystemRand& SystemRand::GetInstance() {
    static SystemRand systemRand;
    return systemRand;
}

}
