#include "stdafx.h"
#include "Wnd.h"
#include "Windows/System.h"
#include "Windows/Dll.h"
#include "Windows/WinAPI.h"
#include "String/Encoding.h"
#include "Utility/Algorithm.h"
//#include <winnls32.h>   //Win3.1̈Y(IMEp)
#include <imm.h>        //IME֌W
#include <shellapi.h>   //::DragAcceptFiles()
#include <shlobj.h>     //DROPFILES
#pragma comment(lib, "imm32.lib")
#pragma comment(lib, "shell32.lib")
namespace Themis {

void CWnd::Update() {
    ::InvalidateRect(m_hWnd, NULL, FALSE);
    ::UpdateWindow(m_hWnd);
}

void CWnd::Update(const CRect& rc) {
    ::InvalidateRect(m_hWnd, &rc, FALSE);
    ::UpdateWindow(m_hWnd);
}

void CWnd::PostUpdate() {
    ::InvalidateRect(m_hWnd, NULL, FALSE);
}

void CWnd::PostUpdate(const CRect& rc) {
    ::InvalidateRect(m_hWnd, &rc, FALSE);
}

void CWnd::UpdateMenubar() {
    ::DrawMenuBar(m_hWnd);
}

CPoint CWnd::GetPos() const {
    CRect rc;
    ::GetWindowRect(m_hWnd, &rc);
    HWND hParent = ::GetParent(m_hWnd);
    if (hParent != NULL) {  //eȂAẽNCAgWŁB
        CPoint pt(0, 0);
        ::ScreenToClient(hParent, &pt);
        pt += rc.GetPoint();
        return pt;
    }
    return rc.GetPoint();
}

CSize CWnd::GetSize() const {
    CRect rc;
    ::GetWindowRect(m_hWnd, &rc);
    return rc.GetSize();
}

void CWnd::SetPosClip(const CPoint& pt) {
    vector<CRect> vct = CSystem::GetAllWorkAreas();
    CSize szWindow = GetSize();
    int nPt2Dist = INT_MAX;
    CPoint pt2;
    for (size_t i = 0, n = vct.size(); i < n; i++) {
        CPoint ptTmp(Max(vct[i].left, Min<long>(pt.x, vct[i].right - szWindow.cx)),
                     Max(vct[i].top, Min<long>(pt.y, vct[i].bottom - szWindow.cy)));
        int nDist = (ptTmp.x - pt.x) * (ptTmp.x - pt.x) + (ptTmp.y - pt.y) * (ptTmp.y - pt.y);
        if (nDist < nPt2Dist) { // 茳̓_ɋ߂̗̂p
            nPt2Dist = nDist;
            pt2 = ptTmp;
        }
    }
    SetPos(pt2);
}

void CWnd::SetCenter() {
    SetCenter(CSystem::GetWorkArea());
}

void CWnd::SetClientSize(const CSize& sz) {
    CRect rc = AdjustWindowRect(CRect(sz));
    SetSize(rc.GetSize());      //TCYݒ[
    for (int i=0; i<3; i++) {   //Ô߉xB
        CSize szClient = GetClientSize();
        if (szClient.cy != sz.cy) {             //j[o[̐܂ԂƂłꂽH
            int nDiff = sz.cy - szClient.cy;     //ǂꂭ炢Ă̂B
            CSize szWnd = GetSize();
            SetSize(CSize(szWnd.cx, szWnd.cy + nDiff));
        }
    }
}

#ifndef SPI_GETFOREGROUNDLOCKTIMEOUT
#define SPI_GETFOREGROUNDLOCKTIMEOUT 0x2000
#endif
#ifndef SPI_SETFOREGROUNDLOCKTIMEOUT
#define SPI_SETFOREGROUNDLOCKTIMEOUT 0x2001
#endif

void CWnd::SetForeground() {
    DWORD dwForeground = ::GetWindowThreadProcessId(::GetForegroundWindow(), NULL);
 // DWORD dwTarget = ::GetWindowThreadProcessId(m_hWnd, NULL);
    DWORD dwTarget = ::GetCurrentThreadId();
    if (dwTarget != dwForeground) {
        ::AttachThreadInput(dwTarget, dwForeground, TRUE);
    }

    DWORD dwTime = 0;
    ::SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, &dwTime, 0);
    ::SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (LPVOID)0, 0);

    ::BringWindowToTop(m_hWnd);
    ::SetForegroundWindow(m_hWnd);

    ::SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, &dwTime, 0);

    if (dwTarget != dwForeground) {
        ::AttachThreadInput(dwTarget, dwForeground, FALSE);
    }
}

void CWnd::CloseForce() {
    if (Exists()) {
        if (::GetCurrentThreadId() == ::GetWindowThreadProcessId(GetHandle(), NULL)) {
            Close();
        } else {
            PostClose();
        }
    }
}

bool CWnd::IsActive() const {
    return ::GetActiveWindow() == m_hWnd;
    // Ȃ񂩂ꂢfalseɂȂ[ȁBB
}

bool CWnd::IsForeground() const {
    return ::GetForegroundWindow() == m_hWnd;
}

bool CWnd::IsMinimized() const {
    WINDOWPLACEMENT p = {sizeof(WINDOWPLACEMENT)};
    BOOL b = ::GetWindowPlacement(m_hWnd, &p);
    Themis_DebugAssertApi(b != FALSE);
    return p.showCmd == SW_SHOWMINIMIZED;
}

bool CWnd::IsMaximized() const {
    WINDOWPLACEMENT p = {sizeof(WINDOWPLACEMENT)};
    BOOL b = ::GetWindowPlacement(m_hWnd, &p);
    Themis_DebugAssertApi(b != FALSE);
    return p.showCmd == SW_SHOWMAXIMIZED;
}

bool CWnd::IsShowNormal() const {
    WINDOWPLACEMENT p = {sizeof(WINDOWPLACEMENT)};
    BOOL b = ::GetWindowPlacement(m_hWnd, &p);
    Themis_DebugAssertApi(b != FALSE);
    return p.showCmd == SW_SHOWNORMAL;
}

string CWnd::GetText() const {
    if (NativeString::IsUnicode()) {
        int nLen = ::GetWindowTextLengthW(m_hWnd) + 1;
        boost::scoped_array<wchar_t> sz(new wchar_t[nLen + 1]);
        ::GetWindowTextW(m_hWnd, sz.get(), nLen);
        return sz.get();
    } else {
        int nLen = ::GetWindowTextLengthA(m_hWnd) + 1;
        boost::scoped_array<char> sz(new char[nLen + 1]);
        ::GetWindowTextA(m_hWnd, sz.get(), nLen);
        return Encoding::GetDefault().GetString(sz.get());
    }
}

void CWnd::SetText(const string& str) {
    NativeString::IsUnicode() ?
        ::SetWindowTextW(m_hWnd, str.ToCharPtr()) :
        ::SetWindowTextA(m_hWnd, Encoding::GetDefault().GetBytes(str).c_str());
}

int CWnd::GetMenuWidth() const {
    if (GetMenu() == NULL)
        return 0;
    int nWidth = 0;
    int nMenuCount = ::GetMenuItemCount(GetMenu());
    CRect rc;
    for (int i=0; i<nMenuCount; i++) {
        ::GetMenuItemRect(m_hWnd, GetMenu(), i, &rc);
        nWidth += rc.GetWidth();
    }
    return nWidth;
}

int CWnd::GetMenuHeight() const {
    int nMenuHeight = ::GetSystemMetrics(SM_CYMENU);
    CRect rcClient; ::GetClientRect(m_hWnd, &rcClient);
    CRect rcTheoretically = AdjustWindowRect(rcClient);    //_l
    CRect rcActual = GetRect();                            //l
    nMenuHeight += rcActual.GetHeight() - rcTheoretically.GetHeight();
    return nMenuHeight;
}

string CWnd::GetClassName() const {
    char sz[0x100];
    ::GetClassName(GetHandle(), sz, lengthof(sz) - 1);
    return Encoding::GetDefault().GetString(sz);
}

/// Ƃ̎ނ̎擾
EWndCtrlType CWnd::GetCtrlType() const {
    string strClass = GetClassName();
    if (strClass == WC_BUTTONW) { return eWndCtrlTypeButton; }
    if (strClass == WC_EDITW) { return eWndCtrlTypeEditbox; }
    if (strClass == WC_STATICW) { return eWndCtrlTypeStatic; }
    if (strClass == WC_LISTBOXW) { return eWndCtrlTypeListbox; }
    if (strClass == WC_COMBOBOXW) { return eWndCtrlTypeCombobox; }
    if (strClass == UPDOWN_CLASSW) { return eWndCtrlTypeUpdown; }
    if (strClass == TRACKBAR_CLASSW) { return eWndCtrlTypeSlider; }
    if (strClass == PROGRESS_CLASSW) { return eWndCtrlTypeProgress; }
    if (strClass == WC_LISTVIEWW) { return eWndCtrlTypeListview; }
    return eWndCtrlTypeNull;
}

void CWnd::DeleteMenu() {
    HMENU hMenu = GetMenu();
    UnsetMenu();
    ::DestroyMenu(hMenu);
}
void CWnd::UnsetMenu() { SetMenu(HMENU(NULL)); }
void CWnd::SetMenu(HMENU hMenu) {
    BOOL bRet = ::SetMenu(m_hWnd, hMenu);
    Themis_DebugAssertApi(bRet != FALSE);
    bRet = ::DrawMenuBar(m_hWnd);
    Themis_DebugAssertApi(bRet != FALSE);
}
void CWnd::SetMenu(UINT nId) {
    HMENU hMenu = ::LoadMenu(::GetModuleHandle(NULL), MAKEINTRESOURCE(nId));
    Themis_DebugAssertApi(hMenu != NULL);
    SetMenu(hMenu);
}
HMENU CWnd::GetMenu() const { return ::GetMenu(m_hWnd); }

void CWnd::UnsetIcon() { SetIcon(static_cast<HICON>(NULL)); }
void CWnd::SetIcon(HICON hIcon) { WarnLess_SetClassLongPtr(m_hWnd, GCL_HICON, reinterpret_cast<LONG_PTR>(hIcon)); }
void CWnd::SetIcon(UINT nId) { SetIcon(::LoadIcon(::GetModuleHandle(NULL), MAKEINTRESOURCE(nId))); }
HICON CWnd::GetIcon() const { return reinterpret_cast<HICON>(WarnLess_GetClassLongPtr(m_hWnd, GCL_HICON)); }

void CWnd::SetBgBlush(HBRUSH hbr) { WarnLess_SetClassLongPtr(m_hWnd, GCLP_HBRBACKGROUND, reinterpret_cast<LONG_PTR>(hbr)); }
HBRUSH CWnd::GetBgBlush() { return reinterpret_cast<HBRUSH>(WarnLess_GetClassLongPtr(m_hWnd, GCLP_HBRBACKGROUND)); }

void CWnd::SetStyle(DWORD s) { ::SetWindowLong(m_hWnd, GWL_STYLE, LONG(s)); }
void CWnd::SetExStyle(DWORD s) { ::SetWindowLong(m_hWnd, GWL_EXSTYLE, LONG(s)); }
DWORD CWnd::GetStyle() const { return static_cast<DWORD>(::GetWindowLong(m_hWnd, GWL_STYLE)); }
DWORD CWnd::GetExStyle() const { return static_cast<DWORD>(::GetWindowLong(m_hWnd, GWL_EXSTYLE)); }

void CWnd::UnsetParent() {
    ::SetParent(m_hWnd, NULL);
    DWORD dw = GetStyle();
    dw &= ~WS_CHILD;
    dw |= WS_POPUP;     //Rł񂾂납BB
    SetStyle(dw);
}
void CWnd::SetParent(HWND hParent) {
    DWORD dw = GetStyle();
    dw &= ~WS_POPUP;
    dw |= WS_CHILD;
    SetStyle(dw);
    ::SetParent(m_hWnd, hParent);
}
HWND CWnd::GetParent() const {
    return ::GetParent(m_hWnd);
}

/// e̐écƒHĐeȂƂ̂Ԃ
HWND CWnd::GetAncestor() const {
    HWND hAncestor = ::GetParent(m_hWnd);
    if (hAncestor == NULL) {
        return NULL;
    }
    HWND hTmp;
    while ((hTmp = ::GetParent(hAncestor)) != NULL) {
        hAncestor = hTmp;
    }
    return hAncestor;
}

void CWnd::SetEnableCloseButton(bool b) {
    if (b) {
        ::EnableMenuItem(::GetSystemMenu(m_hWnd, FALSE), SC_CLOSE, MF_BYCOMMAND | MF_ENABLED);
    } else {
        ::EnableMenuItem(::GetSystemMenu(m_hWnd, FALSE), SC_CLOSE, MF_BYCOMMAND | MF_GRAYED);
    }
 // ::RemoveMenu(::GetSystemMenu(m_hWnd, FALSE), SC_CLOSE, MF_BYCOMMAND);
}

void CWnd::ShowPopupMenu(HMENU hMenu) {
    Themis_DebugAssert(hMenu != NULL);
    UINT uFlags = TPM_LEFTALIGN  | TPM_TOPALIGN     //ɍ킹
                | TPM_LEFTBUTTON | TPM_RIGHTBUTTON; //Ẽ{^ŁB
    POINT pt;
    ::GetCursorPos(&pt);                //J[\̈ʒu擾[
    ::SetForegroundWindow(m_hWnd);      //RȂƃj[ȂȂ鎖BBB
    ::TrackPopupMenu(hMenu, uFlags, pt.x, pt.y, 0, m_hWnd, NULL);
    PostMsg(WM_NULL, 0, 0);
}
void CWnd::ShowPopupMenu(UINT nId) {
    HMENU hMenu = ::LoadMenu(::GetModuleHandle(NULL), MAKEINTRESOURCE(nId));
    ShowPopupMenu(::GetSubMenu(hMenu, 0));
    ::DestroyMenu(hMenu);
}

bool CWnd::IsVisibleHScroll() const {
    CRect rcWnd, rcCln;
    return ::GetWindowRect(GetHandle(), &rcWnd) != FALSE &&
        ::GetClientRect(GetHandle(), &rcCln) != FALSE &&
        ::GetSystemMetrics(SM_CYHSCROLL) <= rcWnd.GetHeight() - rcCln.bottom;
}

bool CWnd::IsVisibleVScroll() const {
    CRect rcWnd, rcCln;
    return ::GetWindowRect(GetHandle(), &rcWnd) != FALSE &&
        ::GetClientRect(GetHandle(), &rcCln) != FALSE &&
        ::GetSystemMetrics(SM_CXVSCROLL) <= rcWnd.GetWidth() - rcCln.right;
}

CSize CWnd::GetValidClientSize() const {
    const int cx = IsVisibleVScroll() ? 0 : ::GetSystemMetrics(SM_CXVSCROLL);
    const int cy = IsVisibleHScroll() ? 0 : ::GetSystemMetrics(SM_CYHSCROLL);
    // ĂȂlAĂȂȂlB
    return GetClientSize() - CSize(cx, cy);
}

void CWnd::ShowIme() {
 // ::WINNLSEnableIME(m_hWnd, TRUE);
    HIMC hImc = ::ImmGetContext(m_hWnd);
    ::ImmSetOpenStatus(hImc, TRUE);
    ::ImmReleaseContext(m_hWnd, hImc);
}

void CWnd::HideIme() {
 // ::WINNLSEnableIME(m_hWnd, FALSE);
    HIMC hImc = ::ImmGetContext(m_hWnd);
    ::ImmSetOpenStatus(hImc, FALSE);
    ::ImmReleaseContext(m_hWnd, hImc);
}

bool CWnd::IsShowIme() const {
 // return ::WINNLSGetEnableStatus(m_hWnd) != FALSE;
    HIMC hImc = ::ImmGetContext(m_hWnd);
    BOOL bRet = ::ImmGetOpenStatus(hImc);
    ::ImmReleaseContext(m_hWnd, hImc);
    return bRet != FALSE;
}

void CWnd::SetTimer(UINT_PTR nIdEvent, UINT nElapse) {
    UINT_PTR r = ::SetTimer(m_hWnd, nIdEvent, nElapse, NULL);
    Themis_DebugAssertApi(r != 0);
}

void CWnd::UnsetTimer(UINT_PTR nIdEvent) {
    ::KillTimer(m_hWnd, nIdEvent);
}

void CWnd::SetAlpha(int nAlpha) {
    if (nAlpha == 0x100) {
        UnsetAlpha();
    } else {
        Themis_DebugAssert(0 <= nAlpha && nAlpha < 0x100);
        static CDll oDll(L"user32.dll", false);
        static CDllFunc4<DWORD, HWND, DWORD, BYTE, DWORD>::T SetLayeredWindowAttributes
            = oDll(L"SetLayeredWindowAttributes", CDllFunc4<DWORD, HWND, DWORD, BYTE, DWORD>());
        SetExStyle(GetExStyle() | 0x80000);
        SetLayeredWindowAttributes(m_hWnd, 0, static_cast<BYTE>(nAlpha), 2);
    }
}
void CWnd::UnsetAlpha() {
    SetExStyle(GetExStyle() & ~0x80000);
}

//// XPALunaȔwi
void CWnd::SetEnableThemeBg(bool bEnable, bool bTab) {
    try {
        CDll oDll(L"UxTheme.dll", false);
        typedef HRESULT (WINAPI* ETDT)(HWND hwnd, DWORD dwFlags);
        ETDT etdt = (ETDT)oDll.GetProc(L"EnableThemeDialogTexture");
        // uxtheme.h B#includeĂB
        const DWORD ETDT_DISABLE       = 0x00000001;
        const DWORD ETDT_ENABLE        = 0x00000002;
        const DWORD ETDT_USETABTEXTURE = 0x00000004;
        const DWORD ETDT_ENABLETAB     = (ETDT_ENABLE  | ETDT_USETABTEXTURE);
        const DWORD dw = bEnable ? (bTab ? ETDT_ENABLETAB : ETDT_ENABLE) : ETDT_DISABLE;
        etdt(GetHandle(), dw);
    } catch (std::exception& e) {
        Themis_DebugLog(e.what()); e;
        // XPȊOŎsƃG[͂Ȃ̂ŁAÔLogB
    }
}

namespace {
    static void EndPaintForCWnd(HWND hWnd, PAINTSTRUCT* p) {
        ::EndPaint(hWnd, p);
        delete p;
    }
}
std::tr1::shared_ptr<PAINTSTRUCT> CWnd::BeginPaint() {
    PAINTSTRUCT* pPaint = new PAINTSTRUCT;
    if (NULL == ::BeginPaint(m_hWnd, pPaint)) {
        Win32Exception e(L"EBhE`IuWFNg̎擾Ɏs");
        delete pPaint;
        throw e;
    }
    return std::tr1::shared_ptr<PAINTSTRUCT>(pPaint, std::tr1::bind(&EndPaintForCWnd, m_hWnd, _1));
}

void CWnd::SetAcceptFiles(bool b) {
    ::DragAcceptFiles(GetHandle(), b? TRUE: FALSE);
}

vector<CFileName> CWnd::GetDropedFiles(WPARAM wParam) {
// Dropꂽt@C̎擾B::DragQueryPoint()͂ǁ[悩BB
    HDROP hDrop = reinterpret_cast<HDROP>(wParam);
    UINT nFiles = ::DragQueryFile(hDrop, 0xFFFFFFFF, NULL, 0); //t@C擾
    vector<CFileName> vct(nFiles);
    for (UINT i = 0; i < nFiles; i++) {
        DWORD dwAttributes;
        if (NativeString::IsUnicode()) {
            wchar_t szBuf[_MAX_PATH];
            ::DragQueryFileW(hDrop, i, szBuf, sizeof(szBuf));
            vct[i] = szBuf;
            dwAttributes = ::GetFileAttributesW(szBuf);
        } else {
            char szBuf[_MAX_PATH];
            ::DragQueryFileA(hDrop, i, szBuf, sizeof(szBuf));
            vct[i] = Encoding::GetDefault().GetString(szBuf);
            dwAttributes = ::GetFileAttributesA(szBuf);
        }
        if (dwAttributes != INVALID_FILE_ATTRIBUTES && (dwAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0) {
            vct[i] += L"\\"; //fBNgȂ؂蕶ǉ
        }
    }
    ::DragFinish(hDrop);
    Themis_DebugAssert(!vct.empty());
    return vct;
}

namespace {
    // ̂炢APIpӂƂĂ[Ǝvc
    HANDLE MakeDropFiles(vector<CFileName>& vctFiles) {
        size_t nSize = 0;
        for (size_t i = 0, n = vctFiles.size(); i < n; i++) {
            std::string mb = Encoding::GetDefault().GetBytes(vctFiles[i].Get());
            nSize += mb.length() + 1;
        }
        nSize += vctFiles.size() + 1; // L'\0'̕ǉ
        HANDLE h = ::GlobalAlloc(GMEM_MOVEABLE, sizeof(DROPFILES) + nSize);
        DROPFILES* p = (DROPFILES*)::GlobalLock(h);
        p->pFiles = sizeof(DROPFILES);
        p->pt.x = 0;
        p->pt.y = 0;
        p->fNC = FALSE;
        p->fWide = FALSE;
        char* psz = (char*)(p + 1);
        for (size_t i = 0, n = vctFiles.size(); i < n; i++) {
            std::string mb = Encoding::GetDefault().GetBytes(vctFiles[i].Get());
            int m = static_cast<int>(mb.length()) + 1;
            memcpy(psz, mb.c_str(), m);
            psz += m;
        }
        psz = L'\0'; // Ō͂B
        ::GlobalUnlock(h);
        return h;
    }
}

void CWnd::DropFiles(vector<CFileName>& vctFiles) {
    PostMsg(WM_DROPFILES, (WPARAM)MakeDropFiles(vctFiles), 0);
}

void CWnd::RemoveQuitMsg() {
    // L[WM_QUITĂƃbZ[W{bNXƂoȂ̂Ŏ̂ĂĂB
    MSG msg;
    for (int i = 0; i < 0x10; i++) { // Ƃ肠ɍȂǍő16
        if (::PeekMessage(&msg, NULL, WM_QUIT, WM_QUIT, PM_REMOVE) != FALSE) {
            if (msg.message == WM_QUIT) {
                Themis_DebugLog(L"WM_QUITPM_REMOVEۂ");
                // QȏĂꍇ邾납BB
                // break;
            }
        } else {
            // ۂȂ炳ƒ߂ďI
            break;
        }
    }
}


RECT CWnd::AdjustWindowRect(RECT rcClient) const {
    BOOL bMenu = (GetMenu()!=NULL) ? TRUE : FALSE;
    RECT rcWindow = rcClient;
    ::AdjustWindowRectEx(&rcWindow, GetStyle(), bMenu, GetExStyle());
    return rcWindow;
}

}
