#include "stdafx.h"
#include <Themis/WndCtrlData.h>
#include <Themis/CommDlg.h>
#include <Themis/CtrlEnable.h>
#include <Themis/Tooltip.h>
#include <Themis/using.h>
#include "resource.h"
#include "Dialogs.h"

CConfigDialog::CConfigDialog(CConfig& r) : CResourceDialogBase(IDD_CONFIG), m_oConfig(r) {
}

CConfigDialog::~CConfigDialog() {
}

bool CConfigDialog::HookMsg(CMsgHookPrms& rPrms) {
    if (rPrms.GetMsg() == WM_COMMAND) {
        UpdateEnables();
        switch (rPrms.GetWPrmLoWord()) {
        case IDOK:
            SaveToConfig();
            GetDialog().Close();
            break;
        case IDCANCEL:
            GetDialog().Close();
            break;
        case IDC_BUTTON1:
            {
                CChooseDir oChooseDir;
                oChooseDir.SetOwner(GetDialog().GetHandle());
                oChooseDir.SetTitle(L"摜tH_̑I");
                oChooseDir.SetDefault(CFileNameModuleDir(GetDialog().Editbox(IDC_EDIT1).GetText()));
                if (oChooseDir.Show()) {
                    GetDialog().Editbox(IDC_EDIT1).SetText(oChooseDir.GetResult().Get());
                }
            }
            break;
        case IDC_BUTTON2:
            {
                CChooseFile oChooseFile;
                oChooseFile.SetOwner(GetDialog().GetHandle());
                oChooseFile.SetTitle(L"ۑt@C̐ݒ");
                oChooseFile.ClearNameFilter();
                oChooseFile.AddNameFilter(L"BMPt@C", L"*.bmp");
                oChooseFile.SetCurrentDir(CFileName(CFileNameModuleDir(GetDialog().Editbox(IDC_EDIT2).GetText()).GetDir()));
                oChooseFile.SetDefaultExt(L"bmp");
                oChooseFile.SetDefault(L"");
                if (oChooseFile.ShowSave()) {
                    GetDialog().Editbox(IDC_EDIT2).SetText(oChooseFile.GetResult().Get());
                }
            }
            break;
        case IDC_BUTTON3:
            {
                CChooseDir oChooseDir;
                oChooseDir.SetOwner(GetDialog().GetHandle());
                oChooseDir.SetTitle(L"SPItH_̑I");
                oChooseDir.SetDefault(CFileNameModuleDir(GetDialog().Editbox(IDC_EDIT3).GetText()));
                if (oChooseDir.Show()) {
                    GetDialog().Editbox(IDC_EDIT3).SetText(oChooseDir.GetResult().Get());
                }
            }
            break;
        }
        return false;
    } else if (rPrms.GetMsg() == WM_INITDIALOG) {
        GetDialog().Combobox(IDC_COMBO1).Add(Array<string>(L"", L"", L"E"));
        GetDialog().Combobox(IDC_COMBO2).Add(Array<string>(L"", L"", L""));
        GetDialog().Combobox(IDC_COMBO3).Add(Array<string>(L"", L"fXNgbv"));
        LoadFromConfig();
        CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
        pTip->Add(IDC_EDIT1, L"摜IԃtH_w肵܂B\r\nŎw肵tH_ȉɂt@C烉_ɑI΂ĕǎɐݒ肳܂B");
        pTip->Add(IDC_EDIT2, L"摜̕ۑw肵܂B\r\nʏ͕ύX̕Kv͂܂B");
        pTip->Add(IDC_EDIT3, L"SPIp摜̓ǂݍ݂sꍇASPÎtH_w肵܂B\r\ngpȂꍇ͓KɖȃtH_w肵ĂĂB");
        pTip->Add(IDC_EDIT4, L"ǎύXԊubPʂŎw肵܂B");
        pTip->Add(IDC_CHECK3, L"񂩂ׂNɕǎύXsǂw肵܂B");
        pTip->Add(IDC_CHECK2, L"摜ʃTCYɍ킹ĊgEk܂B\r\n̏ɂLanczos3gpĂ܂B");
        pTip->Add(IDC_CHECK6, L"gEkɁAc(AXyNg[g)Œ肵ď܂B");
        pTip->Add(IDC_COMBO1, L"ɌԂoꍇɁAǎǂ瑤Ɋ񂹂邩w肵܂B");
        pTip->Add(IDC_COMBO2, L"cɌԂoꍇɁAǎǂ瑤Ɋ񂹂邩w肵܂B");
        pTip->Add(IDC_COMBO3, L"ԂoꍇɁA̐FŖ߂邩w肵܂B");
        pTip->Add(IDC_CHECK4, L"摜̐F̋E܂B");
        pTip->Add(IDC_CHECK5, L"ꎞ~sꍇɁAǎ𖢐ݒ̏Ԃɂ܂B");
        pTip->Add(IDC_RADIO1, L"gCACR̃_uNbNɉ摜̃tH_ύX܂B");
        pTip->Add(IDC_RADIO2, L"gCACR̃_uNbNɕǎ̕ύXs܂B");
        pTip->Add(IDC_RADIO3, L"gCACR̃_uNbNɌ݂̕ǎ̌̃t@CJ܂B");
        pTip->Add(IDC_RADIO4, L"gCACR̃_uNbNɈꎞ~EĊJs܂B");
        pTip->Add(IDC_RADIO5, L"gCACR̃_uNbNɐݒ_CAO\܂B");
        return true;
    } else if (rPrms.GetMsg() == WM_CLOSE) {
        GetDialog().Delete();
        return true;
    } else {
        return false;
    }
}

void CConfigDialog::UpdateEnables() {
    CCtrlEnable(GetDialog().Checkbox(IDC_CHECK2).GetCheck())
        << GetDialog().GetCtrl(IDC_CHECK6)
        ;
    CCtrlEnable(GetDialog().Checkbox(IDC_CHECK2).GetCheck() && GetDialog().Checkbox(IDC_CHECK6).GetCheck())
        << GetDialog().GetCtrl(IDC_COMBO1)
        << GetDialog().GetCtrl(IDC_COMBO2)
        << GetDialog().GetCtrl(IDC_COMBO3)
        ;
}

void CConfigDialog::LoadFromConfig() {
    m_oConfig.FileData(L"ImageDir") >> CEditboxData(GetDialog(), IDC_EDIT1);
    m_oConfig.FileData(L"SaveFile") >> CEditboxData(GetDialog(), IDC_EDIT2);
    m_oConfig.FileData(L"SpiDir") >> CEditboxData(GetDialog(), IDC_EDIT3);
    m_oConfig.NumData(L"Interval(sec)") >> CEditboxData(GetDialog(), IDC_EDIT4);
    !m_oConfig.Bool(L"WaitFirst") >> CCheckboxData(GetDialog(), IDC_CHECK3);
    m_oConfig.BoolData(L"Resize") >> CCheckboxData(GetDialog(), IDC_CHECK2);
    m_oConfig.BoolData(L"ResizeFixedAspectRatio") >> CCheckboxData(GetDialog(), IDC_CHECK6);
    m_oConfig.NumData(L"ResizeAlignH") >> CComboboxData(GetDialog(), IDC_COMBO1);
    m_oConfig.NumData(L"ResizeAlignV") >> CComboboxData(GetDialog(), IDC_COMBO2);
    m_oConfig.NumData(L"ResizeBgColor") >> CComboboxData(GetDialog(), IDC_COMBO3);
    m_oConfig.BoolData(L"Sharp") >> CCheckboxData(GetDialog(), IDC_CHECK4);
    m_oConfig.BoolData(L"RemoveOnSuspend") >> CCheckboxData(GetDialog(), IDC_CHECK5);
    m_oConfig.NumData(L"DoubleClick") >> CRadiosData(GetDialog(), IDC_RADIO1, IDC_RADIO2, IDC_RADIO3, IDC_RADIO4, IDC_RADIO5);
    UpdateEnables();
}

void CConfigDialog::SaveToConfig() {
    m_oConfig.FileData(L"ImageDir") << CEditboxData(GetDialog(), IDC_EDIT1);
    m_oConfig.FileData(L"SaveFile") << CEditboxData(GetDialog(), IDC_EDIT2);
    m_oConfig.FileData(L"SpiDir") << CEditboxData(GetDialog(), IDC_EDIT3);
    m_oConfig.NumData(L"Interval(sec)") << CEditboxData(GetDialog(), IDC_EDIT4);
    m_oConfig.BoolData(L"WaitFirst") << CCheckboxData(GetDialog(), IDC_CHECK3);
    m_oConfig.BoolData(L"Resize") << CCheckboxData(GetDialog(), IDC_CHECK2);
    m_oConfig.BoolData(L"ResizeFixedAspectRatio") << CCheckboxData(GetDialog(), IDC_CHECK6);
    m_oConfig.NumData(L"ResizeAlignH") << CComboboxData(GetDialog(), IDC_COMBO1);
    m_oConfig.NumData(L"ResizeAlignV") << CComboboxData(GetDialog(), IDC_COMBO2);
    m_oConfig.NumData(L"ResizeBgColor") << CComboboxData(GetDialog(), IDC_COMBO3);
    m_oConfig.BoolData(L"Sharp") << CCheckboxData(GetDialog(), IDC_CHECK4);
    m_oConfig.BoolData(L"RemoveOnSuspend") << CCheckboxData(GetDialog(), IDC_CHECK5);
    m_oConfig.NumData(L"DoubleClick") << CRadiosData(GetDialog(), IDC_RADIO1, IDC_RADIO2, IDC_RADIO3, IDC_RADIO4, IDC_RADIO5);

    m_oConfig.Bool(L"WaitFirst", !m_oConfig.Bool(L"WaitFirst"));
}

//----------------------------------------------------------------//
